123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104 |
- #!/bin/sh
- cleanup() {
- rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
- exit 1
- }
- die() {
- echo "$@"
- exit 1
- }
- trap cleanup EXIT
- T=`mktemp` || die "cannot create temp file"
- code=
- while read i ; do
- case "$i" in
- *Code:*)
- code=$i
- ;;
- esac
- done
- if [ -z "$code" ]; then
- rm $T
- exit
- fi
- echo $code
- code=`echo $code | sed -e 's/.*Code: //'`
- width=`expr index "$code" ' '`
- width=$((($width-1)/2))
- case $width in
- 1) type=byte ;;
- 2) type=2byte ;;
- 4) type=4byte ;;
- esac
- disas() {
- ${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
- if [ "$ARCH" = "arm" ]; then
- if [ $width -eq 2 ]; then
- OBJDUMPFLAGS="-M force-thumb"
- fi
- ${CROSS_COMPILE}strip $1.o
- fi
- ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
- grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
- }
- marker=`expr index "$code" "\<"`
- if [ $marker -eq 0 ]; then
- marker=`expr index "$code" "\("`
- fi
- touch $T.oo
- if [ $marker -ne 0 ]; then
- echo All code >> $T.oo
- echo ======== >> $T.oo
- beforemark=`echo "$code"`
- echo -n " .$type 0x" > $T.s
- echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
- disas $T
- cat $T.dis >> $T.oo
- rm -f $T.o $T.s $T.dis
- code=`echo "$code" | cut -c$((${marker} + 1))-`
- fi
- echo Code starting with the faulting instruction > $T.aa
- echo =========================================== >> $T.aa
- code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
- echo -n " .$type 0x" > $T.s
- echo $code >> $T.s
- disas $T
- cat $T.dis >> $T.aa
- faultlinenum=$(( $(wc -l $T.oo | cut -d" " -f1) - \
- $(wc -l $T.aa | cut -d" " -f1) + 3))
- faultline=`cat $T.dis | head -1 | cut -d":" -f2-`
- faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
- cat $T.oo | sed -e "${faultlinenum}s/^\(.*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/"
- echo
- cat $T.aa
- cleanup
|